#include <ctype.h>
#include <string.h>
#include "bmsfel_p.h"

//################################################
// WAVBMP̓o^ppNX

//////////////////////////////////////////////////
// RXgN^Q
BmsRegistArray::BmsRegistArray() {
  for ( int i = 0; i < BmsWord::MAX; ++i ) {
    list[i] = NULL;
  }
  this->set_name( NULL );
}

// name̓Rs[ĎÖ̗ɕۑ
BmsRegistArray::BmsRegistArray( const char *name ) {
  for ( int i = 0; i < BmsWord::MAX; ++i ) {
    list[i] = NULL;
  }
  this->set_name( name );
}

// fXgN^
BmsRegistArray::~BmsRegistArray() {
  this->clear();
  delete [] this->name;
}

//////////////////////////////////////////////////
// ẽIuWFĕԂ delete͌Ăяo
BmsRegistArray *BmsRegistArray::clone() const {
  BmsRegistArray *copy = new BmsRegistArray( this->name );
  for ( int i = 0; i < BmsWord::MAX; ++i ) {
    copy->overwrite( BmsWord( i ), this->list[i] );
  }
  return copy;
}

//////////////////////////////////////////////////
// getn
const char *BmsRegistArray::get_name() const {
  return (const char *)this->name;
}

int BmsRegistArray::get_exist_count() const {
  int count = 0;
  for ( int i = 0; i < BmsWord::MAX; ++i ) {
    if ( this->is_exist( i ) ) { ++count; }
  }
  return count;
}

//////////////////////////////////////////////////
// setn
// name̓Rs[ĎOŗ̈mۂ
void BmsRegistArray::set_name( const char *name ) {
  if ( name == NULL ) { name = ""; }

  this->name = BmsUtil::str_new_cpy( name, true );
}

//////////////////////////////////////////////////
// i[
// ̈̓Rs[ĎOŗ̈mۂ ߂l͏㏑ǂ
bool BmsRegistArray::overwrite( BmsWord nth, const char *value ) {
  bool return_value = false;
  if ( this->list[nth.get_int()] != NULL ) {
    this->delete_at( nth );
    return_value = true;
  }

  this->list[nth.get_int()] = BmsUtil::str_new_cpy( value, false );

  return return_value;
}

// Oŗ̈mۂȂ valuedelete̓Rei
bool BmsRegistArray::overwrite_in( BmsWord nth, char *value ) {
  bool return_value = false;
  if ( this->list[nth.get_int()] != NULL ) {
    this->delete_at( nth );
    return_value = true;
  }

  this->list[nth.get_int()] = value;

  return return_value;
}

//////////////////////////////////////////////////
// vfǂ
bool BmsRegistArray::is_exist( BmsWord nth ) const {
  if ( this->list[nth.get_int()] == NULL ) { return false; }
  return true;
}
// vfǂ
bool BmsRegistArray::is_empty( BmsWord nth ) const {
  return !(this->is_exist( nth ));
}

//////////////////////////////////////////////////
// vfQƂ delete͈ڂȂ
const char *BmsRegistArray::at( BmsWord nth ) const {
  if ( this->list[nth.get_int()] != NULL ) {
    return (const char *)this->list[nth.get_int()];
  }
  return "";
}

//////////////////////////////////////////////////
// vfo delete͌Ăяo
char *BmsRegistArray::take_at( BmsWord nth ) {
  char *temp = this->list[nth.get_int()];
  this->list[nth.get_int()] = NULL;
  return temp;
}

//////////////////////////////////////////////////
// vf폜 ߂l͎ۂɍ폜ǂ
bool BmsRegistArray::delete_at( BmsWord nth ) {
  bool return_value = false;
  char *temp = this->take_at( nth );
  if ( temp != NULL ) {
    delete [] temp;
    return_value = true;
  }
  return return_value;

}

//////////////////////////////////////////////////
// vfЂƂ菜Ԃ delete͌Ăяo
// *valuë̗(\ȗ̈悪Kv)ɏ vfꍇfalseԂ
bool BmsRegistArray::shift( BmsWord *nth, char *value ) {
  for ( int i = 0; i < BmsWord::MAX; ++i ) {
    if ( this->list[i] != NULL ) {
      nth->set( i );
      strcpy( value, this->at( BmsWord( i ) ) );
      this->delete_at( BmsWord( i ) );
      return true;
    }
  }
  return false;
}

//////////////////////////////////////////////////
// gɂ ߂l͏
int BmsRegistArray::clear() {
  int deleted_num = 0;
  for ( int i = 0; i < BmsWord::MAX; ++i ) {
    if ( this->delete_at( BmsWord( i ) ) ) { ++deleted_num; }
  }
  return deleted_num;
}

//////////////////////////////////////////////////
// ȍ~̓[eBeBn

// str̍\ɂĂ邩ǂ
// #???@@ value ł [??? => name] [@@ => 00-ZZ] ǂ`FbN
bool BmsRegistArray::check_structure( const char *str ) const {
  bool return_value = false;
  int name_length = strlen( this->get_name() );

  char *temp = new char[name_length + 1];
  strncpy( temp, str, name_length );
  temp[name_length] = '\0';
  BmsUtil::str2upper( temp );
  
  if ( strcmp( temp, this->get_name() ) == 0 ) {
    if ( isalnum( str[name_length] ) && isalnum( str[name_length + 1] ) ) {
      if ( str[name_length + 2] == ' ' || str[name_length + 2] == '\t' || str[name_length + 2] == '\0' ) {
        return_value = true;
      }
    }
  }
  
  delete temp;
  return return_value;
}
